CON
    JOY_CLK      = 23
    JOY_LCH      = 24
    JOY_DATAOUT0 = 25
    JOY_DATAOUT1 = 26

    RIGHT    = %00000000_00000001
    LEFT     = %00000000_00000010
    DOWN     = %00000000_00000100
    UP       = %00000000_00001000
    START    = %00000000_00010000
    SELECT   = %00000000_00100000
    B        = %00000000_01000000
    A        = %00000000_10000000

VAR
  word  nes_bits

PUB getCurrentState
  NES_Read_Gamepad
  return nes_bits

PUB getLastState
  return nes_bits

PRI NES_Read_Gamepad | i
  DIRA [JOY_CLK] := 1 ' output
  DIRA [JOY_LCH] := 1 ' output
  DIRA [JOY_DATAOUT0] := 0 ' input
  DIRA [JOY_DATAOUT1] := 0 ' input
  OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
  OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
  OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
  OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
  nes_bits := 0
  repeat i from 0 to 7
    nes_bits := (nes_bits << 1)
    nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)
    OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
    OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
  nes_bits := (!nes_bits & $FFFF)

